package;

import zygame.mini.MiniUtils;
import zygame.display.batch.BImage;
import zygame.display.batch.ImageBatchs;
import zygame.utils.FPSUtil;
import openfl.events.TouchEvent;
import zygame.components.ZLabel;
import zygame.mini.MiniEngineScene;

/**
 * 小游戏测试引擎Demo
 */
class Main extends MiniEngineScene {
	public var beginX:Float = 0;

	public var beginY:Float = 0;

	public var roleBegineX:Float = 0;

	public var roleBegineY:Float = 0;

	public var role:Role;

	public var isMove:Bool = false;

	public var fps:FPSUtil;

	/**
	 * 敌人列表
	 */
	public static var enemys:Array<Enemy>;

	public var planeRoot:ImageBatchs;

	override function onInit() {
		super.onInit();
		Main.enemys = [];
		this.setFrameEvent(true);
		fps = new FPSUtil(1);

		planeRoot = new ImageBatchs(assets.getTextureAtlas("Plane"));
		this.addChild(planeRoot);

		var bg:BImage = new BImage(assets.getBitmapData("Plane:bg"));
		planeRoot.addChild(bg);
		bg.x = (this.getStageWidth() - bg.width) / 2;
		bg.y = (this.getStageHeight() - bg.height) / 2;

		role = new Role();
		role.playAnmin(this.assets.getTextureAtlas("Plane"), "hero");
		planeRoot.addChild(role);
		role.x = this.getStageWidth() / 2 - role.width / 2;
		role.y = this.getStageHeight() - 200 - 50;

		this.setTouchEvent(true);

	}

	override function onTouchBegin(e:TouchEvent) {
		super.onTouchBegin(e);
		this.beginX = e.localX;
		this.beginY = e.localY;
		this.roleBegineX = role.x;
		this.roleBegineY = role.y;
		isMove = true;
	}

	override function onTouchMove(e:TouchEvent) {
		super.onTouchMove(e);
		if (isMove && !MiniUtils.getApp().isPause()) {
			role.x = this.roleBegineX + e.localX - this.beginX;
			role.y = this.roleBegineY + e.localY - this.beginY;
		}
	}

	override function onTouchEnd(e:TouchEvent) {
		super.onTouchEnd(e);
		isMove = false;
	}

	override public function onFrame():Void {
		if (MiniUtils.getApp().isPause())
			return;
		if (fps.update()) {
			if (Main.enemys.length < 10) {
				var enemy = new Enemy();
				planeRoot.addChild(enemy);
				enemy.x = Math.random() * this.getStageWidth();
				Main.enemys.push(enemy);
			}
		}
	}
}
