import zygame.display.batch.BAnimation;
import zygame.utils.FPSUtil;
import zygame.components.data.AnimationData;
import zygame.mini.MiniUtils;
import zygame.utils.load.TextureLoader.TextureAtlas;

/**
 * 控制角色
 */
class Role extends BAnimation {

	/**
	 * 飞机HP
	 */
	public var hp:Int = 10;

	public var fps:FPSUtil;

    override function onInit() {
        super.onInit();
        fps = new FPSUtil(12);
        trace("Role.onInit");
    }

	override function onFrame() {
		if(MiniUtils.getApp().isPause())
			return;
		super.onFrame();
		if (fps.update()) {
			var bullet = this.createBullet();
			this.getParent().addChild(bullet);
			bullet.x = this.x + this.width / 2 - bullet.width / 2;
			bullet.y = this.y;
		}
	}

	/**
	 * 创建动画
	 * @param animId
	 */
	public function playAnmin(texture:TextureAtlas, animId:String):Void {
		var data = new AnimationData(12);
		data.addFrames(texture.getBitmapDataFrames(animId));
		this.dataProvider = data;
		this.play();
        trace("播放角色动画！");
	}

	public function createBullet():Bullet {
		var bullet2 = new Bullet();
		return bullet2;
	}
}
